precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float progress;
uniform int strength;

const  vec4  kRGBToYPrime = vec4 (0.299, 0.587, 0.114, 0.0);
const  vec4  kRGBToI     = vec4 (0.595716, -0.274453, -0.321263, 0.0);
const  vec4  kRGBToQ     = vec4 (0.211456, -0.522591, 0.31135, 0.0);

void main()
{
    vec4 origColor = texture2D(inputImageTexture, textureCoordinate.xy);
    origColor.g += progress * 0.05;
    origColor.b += progress * (0.3 + 0.05 * float(strength));

    vec4 yiqMaskColor = texture2D(inputImageTexture, textureCoordinate.xy);
    // Convert to YIQ
    float   YPrime  = dot (yiqMaskColor, kRGBToYPrime);
    float   I      = dot (yiqMaskColor, kRGBToI);
    float   Q      = dot (yiqMaskColor, kRGBToQ);
    yiqMaskColor = origColor;
    if (YPrime < 0.5)
    {
        yiqMaskColor.g = yiqMaskColor.r = 1.0 - YPrime;
    }

    gl_FragColor = mix(origColor, yiqMaskColor, (0.3 + 0.2 * float(strength))  * progress);
}