precision mediump float;
 varying vec2 textureCoordinate;
 uniform sampler2D inputImageTexture;

 uniform float progress;
 uniform int strength;

 void main()
 {
     if (strength == 0)
     {
         gl_FragColor = texture2D(inputImageTexture, textureCoordinate.xy);
         return;
     }

     vec4 finalColor = texture2D(inputImageTexture, textureCoordinate.xy);

     // 如果强度是3或4，加上三色分离效果
     if (strength > 2)
     {
         float strength2 = 0.5;
         if (strength > 3)
         {
             strength2 = 2.0;
         }
         float progress2 = progress;
         if(progress2 > 0.5)
         {
             progress2 = 1.0 - progress2;
         }
         progress2 = progress2 * 2.0;
         vec2 origPosition = textureCoordinate.xy;

         vec4 origColor = finalColor;

         vec2 offsetRed = (vec2(0.02, 0.008) ) * progress2 * (1.0 + ((strength2) - 1.0) * 0.3);
         vec2 offsetGreen = vec2(-0.005, 0.0) * progress2 * (1.0 + ((strength2) - 1.0) * 0.3);
         vec2 offsetBlue = vec2(-0.02, 0.0) * progress2 * (1.0 + ((strength2) - 1.0) * 0.3);

         vec2 redPos = origPosition + offsetRed;
         vec2 greenPos = origPosition + offsetGreen;
         vec2 bluePos = origPosition + offsetBlue;

         vec4 redColor = texture2D(inputImageTexture, redPos) * (1.0 + (strength2) * 0.05);
         vec4 greenColor = texture2D(inputImageTexture, greenPos) * (1.0 + (strength2) * 0.05);
         vec4 blueColor = texture2D(inputImageTexture, bluePos) * (1.0 + (strength2) * 0.05);

        finalColor = vec4(redColor.r, greenColor.g, blueColor.b, 1.0);
     }

     float firstMaskStartProgress = 0.0;
     float firstMaskEndProgress = 0.6 / 0.6;
     float firstMaskTopProgress = 0.3 / 0.6;

     float secondMaskStartProgress = 0.1 / 0.6;
     float secondMaskEndProgress = 1.0;
     float secondMaskTopProgress = 0.4 / 0.6;
     if(progress >= firstMaskStartProgress && progress <= firstMaskEndProgress)
     {
         vec2 center = vec2(0.5, 0.5);

         //第一层mask
         float adjustProgress = 0.0;
         if (progress < firstMaskTopProgress)
         {
             adjustProgress = (progress - firstMaskStartProgress) / (firstMaskTopProgress - firstMaskStartProgress);
         }
         else
         {
             adjustProgress = (firstMaskEndProgress - progress) / (firstMaskEndProgress - firstMaskTopProgress);
         }

         float resizeRatio = 1.0 + (0.3 + 0.1 * float(strength)) * (progress - firstMaskStartProgress)/ (firstMaskEndProgress - firstMaskStartProgress);
         float alpha = (0.3 + 0.05 * float(strength)) * adjustProgress;

         vec2 origPosition = center + (textureCoordinate - center) / resizeRatio;
         vec4 firstMaskColor = texture2D(inputImageTexture, origPosition);

         finalColor = mix(finalColor, firstMaskColor, alpha);
     }
     /* 只要一层Mask了
     if(progress >= secondMaskStartProgress && progress <= secondMaskEndProgress)
     {
         //第二层mask
         float adjustProgress = 0.0;
         if (progress < secondMaskTopProgress)
         {
             adjustProgress = (progress - secondMaskStartProgress) / (secondMaskTopProgress - secondMaskStartProgress);
         }
         else
         {
             adjustProgress = (secondMaskEndProgress - progress) / (secondMaskEndProgress - secondMaskTopProgress);
         }

         float resizeRatio = 1.0 + (0.6 + float(strength) * 0.1) * (progress - secondMaskStartProgress)/ (secondMaskEndProgress - secondMaskStartProgress);
         float alpha = 0.2 * adjustProgress;

         vec2 origPosition = center + (textureCoordinate - center) / resizeRatio;
         vec4 secondMaskColor = texture2D(inputImageTexture, origPosition);

         finalColor = mix(finalColor, secondMaskColor, alpha);
     }
     */
     gl_FragColor = finalColor;
 }