precision mediump float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float progress;
uniform int strength;

void main()
{
    // 先做缩放到110%
    float resizeRatio = 1.0 + 0.1 * progress;
    vec2 center = vec2(0.5, 0.5);
    vec2 origPosition = center + (textureCoordinate - center) / resizeRatio;

    vec4 origColor = texture2D(inputImageTexture, origPosition);

    vec2 offsetRed = vec2(0.02, 0.008) * progress;
    vec2 offsetGreen = vec2(-0.005, 0.0) * progress;
    vec2 offsetBlue = vec2(-0.02, 0.0) * progress;

    vec2 redPos = origPosition + offsetRed;
    vec2 greenPos = origPosition + offsetGreen;
    vec2 bluePos = origPosition + offsetBlue;

    vec4 redColor = texture2D(inputImageTexture, redPos);
    vec4 greenColor = texture2D(inputImageTexture, greenPos);
    vec4 blueColor = texture2D(inputImageTexture, bluePos);

    gl_FragColor = vec4(redColor.r, greenColor.g, blueColor.b, 1.0);
}

