precision mediump float;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate;
uniform float progress;
uniform int strength;
void main()
{
    float plusParam = 0.05*sin(progress*3.14)*float(strength);
    float resizeRatio = 1.0 + plusParam;
    vec2 center = vec2(0.5, 0.5);
    vec2 origPosition = center + (textureCoordinate - center) / resizeRatio;
    vec4 destFragColor = texture2D(inputImageTexture, origPosition);
    if (strength == 4) {
        float average = (destFragColor.r + destFragColor.g + destFragColor.b) / 3.0;
        vec3 minusParam = vec3(destFragColor.r - average,destFragColor.g - average,destFragColor.b - average)*(float(strength)*0.15);
        gl_FragColor = vec4(destFragColor.r - minusParam.r,destFragColor.g - minusParam.g,destFragColor.b - minusParam.b,1.0);
    }else
        gl_FragColor = destFragColor;
}
